#include<stdio.h>
#include<stdlib.h>
#include<string.h>

struct elemento{
	char *id;
	struct elemento *next;
};
typedef struct elemento elemento_t;

void free_element(elemento_t* elem){
	free(elem->id);
	free(elem);
}

struct lista{
	elemento_t* first;
	int num;
};
typedef struct lista lista_t;

lista_t new(){
	lista_t result;
	result.first=NULL;
	result.num=0;
	return result;
}

void push(char *val, lista_t *lista){

	elemento_t* elem=(elemento_t*)malloc(sizeof(elemento_t));
	elem->id=(char*)malloc((strlen(val)+1)*sizeof(char));
	strcpy(elem->id,val);
	elem->next=NULL;

	if(lista->num==0){
		lista->first=elem;
	}else{
		elemento_t* p=lista->first;
		while(p->next!=NULL){
			p=p->next;		
		}
	p->next=elem;
	}
	lista->num++;

}

char* pop(lista_t *lista){
    char *par=NULL;
	if(lista->num==1){
		par=lista->first->id;
		free(lista->first);
        lista->first=NULL;
     	lista->num--;
	}else if(lista->num!=0){
		elemento_t* p=lista->first;
		while(p->next->next!=NULL){
			p=p->next;		
		}
		par=p->next->id;
		free(p->next);
		p->next=NULL;
     	lista->num--;
		}
   	return par;
}

void lista_stampa(lista_t *lista){
	if(lista->num==0){
		printf("La lista  vuota!\n");
	}else{
		printf("{");
		elemento_t* p= lista->first;
			while(p!=NULL){
				printf("%s", p->id);
				p=p->next;
				if (p!=NULL)
				   printf(",");
			}
		printf("}\n");
	}
}

void stats(lista_t *lista){
	if(lista->num==0){
		printf("La lista  vuota!\n");
	}else{
        int somma=0;
		elemento_t* p= lista->first;
			while(p!=NULL){
				somma=somma+strlen(p->id);
				p=p->next;
			}
		printf("Somma=%d Media=%f\n",somma,(float)somma/lista->num);
	}
}

int main(){
	char str[100];
	lista_t frase=new();
	lista_t frase_inversa=new();
	char parola[15];

	printf("Immettere una frase (parole separate da spazi): ");
	scanf("%[^\n]",str);
    getchar(); //serve per pulire lo stdin dall'acapo di prima

	int i=0;
	int j=0;
	while (str[j]!='\0') {
    j++;
	while((str[j]!=' ')&&(str[j]!='\0'))
		j++;
	strncpy(parola,str+i,j-i);
	parola[j-i]='\0';
	push(parola, &frase);   
	i=j+1;
	} 
    printf("Frase---> ");
	lista_stampa(&frase);
    printf("Statistiche---> ");
	stats(&frase);
	while (frase.num) {
      push(pop(&frase),&frase_inversa);
	  }
    printf("Frase Inversa---> ");
	lista_stampa(&frase_inversa);
	
	char ch;
	scanf("%s",&ch);

	return 1;	
}
